Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.functors
Class SwitchClosure

    java.lang.Object
      org.apache.commons.collections.functors.SwitchClosure

All Implemented Interfaces:
  java.io.Serializable, Closure

    public class SwitchClosure

extends java.lang.Object
implements Closure, java.io.Serializable

Closure implementation calls the closure whose predicate returns true, like a switch statement.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Constructor Summary
`SwitchClosure(Predicate[] predicates, Closure[] closures, Closure defaultClosure)` Constructor that performs no validation.

Method Summary
`void` | `execute(java.lang.Object input)` Executes the closure whose matching predicate returns true
`Closure[]` | `getClosures()` Gets the closures, do not modify the array.
`Closure` | `getDefaultClosure()` Gets the default closure.
`static Closure` | `getInstance(java.util.Map predicatesAndClosures)` Create a new Closure that calls one of the closures depending on the predicates.
`static Closure` | `getInstance(Predicate[] predicates, Closure[] closures, Closure defaultClosure)` Factory method that performs validation and copies the parameter arrays.
`Predicate[]` | `getPredicates()` Gets the predicates, do not modify the array.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SwitchClosure

    public SwitchClosure(Predicate[] predicates,
                         Closure[] closures,
                         Closure defaultClosure)

  Constructor that performs no validation. Use `getInstance` if you want that.

  Parameters:
    `predicates` - array of predicates, not cloned, no nulls
    `closures` - matching array of closures, not cloned, no nulls
    `defaultClosure` - the closure to use if no match, null means nop

Method Detail

### getInstance

    public static Closure getInstance(Predicate[] predicates,
                                      Closure[] closures,
                                      Closure defaultClosure)

  Factory method that performs validation and copies the parameter arrays.

  Parameters:
    `predicates` - array of predicates, cloned, no nulls
    `closures` - matching array of closures, cloned, no nulls
    `defaultClosure` - the closure to use if no match, null means nop
  Returns:
    the `chained` closure
  Throws:
    `java.lang.IllegalArgumentException` - if array is null
    `java.lang.IllegalArgumentException` - if any element in the array is null

### getInstance

    public static Closure getInstance(java.util.Map predicatesAndClosures)

  Create a new Closure that calls one of the closures depending on the predicates.

  The Map consists of Predicate keys and Closure values. A closure is called if its matching predicate returns true. Each predicate is evaluated until one returns true. If no predicates evaluate to true, the default closure is called. The default closure is set in the map with a null key. The ordering is that of the iterator() method on the entryset collection of the map.

  Parameters:
    `predicatesAndClosures` - a map of predicates to closures
  Returns:
    the `switch` closure
  Throws:
    `java.lang.IllegalArgumentException` - if the map is null
    `java.lang.IllegalArgumentException` - if any closure in the map is null
    `java.lang.ClassCastException` - if the map elements are of the wrong type

### execute

    public void execute(java.lang.Object input)

  Executes the closure whose matching predicate returns true

  Specified by:
    `execute` in interface `Closure`
  Parameters:
    `input` - the input object

### getPredicates

    public Predicate[] getPredicates()

  Gets the predicates, do not modify the array.

  Returns:
    the predicates
  Since:
    Commons Collections 3.1

### getClosures

    public Closure[] getClosures()

  Gets the closures, do not modify the array.

  Returns:
    the closures
  Since:
    Commons Collections 3.1

### getDefaultClosure

    public Closure getDefaultClosure()

  Gets the default closure.

  Returns:
    the default closure
  Since:
    Commons Collections 3.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.